-- CLCProt 4.0.00.003 beta .03 for WoW Warlords of Draenor 6.0.3 (pre-patch)
-- by Adeya, player of Paladin DyeimiAdeya currently on Garona_US
--
--   The CLCProt 4.x files include "YOU MUST READ ME NOW" (.rtf), which has  
-- that name because it is true. :-) It is in the same folder as clcprot.lua.
--
--   CLCProt 4.x is the successor of "CLCProt for WoW Mists of Pandaria 5.4".
-- It is updated for WoW Warlords of Draenor 6.x, to include its new features 
-- and many changes which have been documented by Blizzard Entertainment and 
-- by fan websites such as Wowhead, Wowpedia, Maintankadin, and Elitist Jerks.
--
--  See also the comments at the beginning of rotation.lua.
--
-- COURTESY NOTICE: the Lua scripting language is Copyright © 1994–2014 Lua.org, 
-- PUC-Rio. The Lua license is available at http://www.lua.org/license.html
--
-------------------------------------------------------------------------------=

local _, trueclass = UnitClass("player")
if trueclass ~= "PALADIN" then return end

if ( UnitLevel("player") < 45 ) then 
	message("The paladin must be Level 45 or higher to use CLCProt!")
end

local GetTime = GetTime

-- shortcut for db options
local db

clcprot = LibStub("AceAddon-3.0"):NewAddon("clcprot", "AceEvent-3.0", "AceConsole-3.0")

local MAX_AURAS = 20
local BGTEX = "Interface\\AddOns\\clcprot\\textures\\minimalist"
local BORDERTEX = "Interface\\AddOns\\clcprot\\textures\\border"
local borderType = {
	"Interface\\AddOns\\clcprot\\textures\\border",					-- light
	"Interface\\AddOns\\clcprot\\textures\\border_medium",			-- medium
	"Interface\\AddOns\\clcprot\\textures\\border_heavy"			-- heavy
}

local strataLevels = {
	"BACKGROUND",
	"LOW",
	"MEDIUM",
	"HIGH",
	"DIALOG",
	"FULLSCREEN",
	"FULLSCREEN_DIALOG",
	"TOOLTIP",
}

local dq = { 31935, 31935 }			--dA: 31935 is avenger's shield id 
local nq = {}
nq[1] = GetSpellInfo(31935)
nq[2] = GetSpellInfo(31935)

local hrname = GetSpellInfo(53595)	--dA: 53595 is hammer of the righteous id

-- main and secondary skill buttons
-- smartsvn test
local buttons = {}
-- configurable buttons
local auraButtons = {}
local enabledAuraButtons
local numEnabledAuraButtons 
local auraIndex

local icd = {}
local playerName

-- addon status
local addonEnabled = false			-- enabled
local addonInit = false				-- init completed
clcprot.locked = true				-- main frame locked

--[[
clcprot.auraButtons = auraButtons
clcprot.icd = icd
--]]

local s_hwFinal = false		-- true while the Glyph of Final Wrath is socketed

-----------------------------------------------------------------------------------------------------------------------
-- global variables			--dA: these are assigned values in clcprot.lua, and used also in rotation.lua
-----------------------------------------------------------------------------------------------------------------------

  s_protSpec = false		-- true if the paladin's spec is protection, else false
  talentGroup = nil			-- whether protection spec is paladin's primary spec (= 1) or secondary spec (= 2)

-- talent and glyph flags
  s_eft = false				-- true while T3 L45 Eternal Flame talent selected
  s_swt = false				-- true while Sanctified Wrath is selected
  s_goc = false				-- true while Glyph of Consecration is in effect

  consId			= 26573	 	-- Consecration ID, depending upon whether GoC is in effect (no glyph is default)
--  consGlyphId		= 54928	 	-- Glyph of Consecration 
--  consIdGlyphed	= 116467 	-- consecration with gylph
--  consIdNoGlyph	= 26573  	-- consecration without glyph 	

  s_queue = true 			-- true when either priority sequence has changed and must be validated
  s_initPrio  = true		-- true until the initial priority sequence is displayed on ChatFrame1
  useAltPrio  = false		-- true while the alternate priority sequence is the default
  prioToggled = "no"		-- assigned "qn" or "qa" when default priority is changed (reset to "no")

  useEFGalt = false			-- true when player chooses to use the Glorious Eternal Flame alternative
  useWoGalt = false			-- true when player chooses to use the Word of Glory alternative 
    
  s1_twm = false			-- true while the AoE of the spell in s1 must be chosen with a mouse 
  s2_twm = false			-- true while the AoE of the spell in s2 must be chosen with a mouse 

  rota = 0					-- tally of calls to clcprot.ProtRotation() since CLCProt was loaded (debugging)
  t_rspan = 0				-- the amt of time between the start of one rotation and the start of the next
 	
----: globals initialized in rotation.lua:

  -- actions						-- dA: object defined in rotation.lua containing data & methods for actions

-- ---------------------------------------------------------------------------------------------------------------------
-- DEFAULT VALUES
-- ---------------------------------------------------------------------------------------------------------------------

local defaults = {
	profile = {
		version = 6,
		
		-- layout settings for the main frame (the black box you toggle on and off)\
		zoomIcons = true,
		noBorder = false,
		borderColor = {0, 0, 0, 1},
		borderType = 2,
		x = 500,
		y = 300,
		scale = 1,
		alpha = 1,
		show = "always",
		fullDisable = false,
		strata = 3,
		grayOOM = false,
		
		-- paladin power bar								--dA: apparently deprecated
		adjustHPBar = true,
		hideBlizPPB = false,
		ppbX = 0,
		ppbY = 0,
		ppbScale = 1,
		ppbAlpha = 1,
		
		lbf = 
		{
			Skills = {},
			Auras = {},
		},
		
		-- icd
		icd = 
		{
			visibility = 
			{
				ready = 1,
				cd = 3,
			},
		},

		rotation = 
		{
			--dA: normal queue		(single-target by default)
			prio = "efg ss wog sotr cs j asgc hwf as hw es lh how hpr cons",				--dA: revised
			prio_def = "efg ss wog sotr cs j asgc hwf as hw es lh how hpr cons",			--dA: default if prio == ""
			--dA: alternate queue	(multi-target by default)
			defaultPrioAlt = false,
			prioAlt = "efg ss wog sotr asgc hotr j hwf as hw es lh how cons hpr", 			--dA: revised
			prioAlt_def = "efg ss wog sotr asgc hotr j hwf as hw es lh how cons hpr",		--dA: default if prio == ""

			--dA: action configuration settings ---------------------------------------------------

			-- Eternal Flame 			
			-- first EF configuration - continuous use
			             				-- applied ordinarily 
			efcHP = 3,					-- min HP to use efc (range 1 - 5)
			efcRefresh = 6,				-- refresh efc at x seconds left (range 0 - 12)
			efcBoG = 2,					-- min BoG stacks to use efc (range 0 - 5)
			efcxpHP = 3,				-- min HP to use efc if not active (range 1 - 3)
			--expiration
			efcBoGhp = 3,				-- min HP to use expiring BoG for efc (range 1 - 5)
			efcBoGstk = 2,				-- min expiring BoG stack to use efc (range 1 - 5)
			efcBoGxp = 4,				-- min secs. left to use BoG for efc (range 3 - 12)

			--4T16						-- applied while 4-piece Tier 16 set bonus is available
			efc4T16Refresh = 6,			-- refresh efc at x seconds left (range 0 - 12)
			efc4T16BoG = 3,				-- min BoG stack to use efc (range 3 - 5)
			--expiration
			efc4T16BoGxp = 4,			-- min secs. left to use BoG for efc (range 3 - 12)	
			efc4T16BoGstk = 3,			-- min expiring BoG stack to use efc (range 3 - 5)

			--DP						-- applied during Divine Purpose 
			efcdpRefresh = 6,			-- refresh efc at x seconds left (range 0 - 12)
			efcdpBoG = 2,				-- min BoG stacks to use efc (range 0 - 5)
			--expiration
			efcdpBoGstk = 2,			-- min expiring BoG stack to use efc (range 1 - 5)
			efcdpBoGxp = 4,				-- min secs. left to use BoG for efc (range 3 - 12)

			--HA						-- applied during Holy Avenger
			efchaHP = 3,				-- min HP to use efc during HA (range 1 - 5)
			efchaRefresh = 10,			-- refresh efc at x seconds left (range 0 - 12)
			efchaBoG = 4,				-- min BoG stack to use efc (range 0 - 5)
			--expiration
			efchaBoGhp = 3,				-- min HP to use expiring BoG for efc (range 1 - 5)
			efchaBoGstk = 4,			-- min expiring BoG stack to use efc (range 1 - 5)
			efchaBoGxp = 4,				-- min secs. left to use BoG for efc (range 3 - 12)

			--SW						-- applied during Sanctified Wrath
			efcswHP = 3,				-- min HP to use efc during SW
			efcswRefresh = 10,			-- refresh efc at x seconds left (range 0 - 12)
			efcswBoG = 3,				-- min BoG stacks to use efc (range 0 - 5)
			--expiration
			efcswBoGhp = 3,				-- min HP to use expiring BoG for efc (range 1 - 5)
			efcswBoGstk = 3,			-- min expiring BoG stack to use efc (range 1 - 5)
			efcswBoGxp = 4,				-- min secs. left to use BoG for efc (range 3 - 12)
			
			-- second EF configuration - situational use
			--default 					-- applied ordinarily 
			efgHP = 3,					-- min HP to use efg ordinarily (range 1 - 5)
			efgBoG = 3,					-- min BoG stack to use efg (range 0 - 5)
			efgHealth = 75,				-- percent of Health left to use efg (range 21 - 100)
			--alternate					-- alternative efg applied ordinarily 
			useEFGalt = false,			-- true if player chooses the efg alternative
			efgAltHP = 3,				-- min HP to use efg (range 1 - 5)
			efgAltBoG = 2,				-- min BoG stack to use efg (range 0 - 5)
			efgAltHealth = 95,			-- percent of Health left to use alt efg (range 21 - 100)

			--4T16						-- applied while 4-piece Tier 16 set bonus is available
			efg4T16BoG = 3,				-- min BoG stack to use efg (range 3 - 5)
			efg4T16Health = 75,			-- percent Health left to use efg (range 21 - 100)
			--alternate
			efg4T16AltBoG = 3,			-- min BoG stack to use alternate efg (range 3 - 5)
			efg4T16AltHealth = 95,		-- percent of Health left to use alt efg (range 21 -100)

			--DP						-- applied during Divine Purpose
			efgdpBoG = 3,				-- min BoG stack to use efg during DP (range 0 - 5)
			efgdpHealth = 75,			-- percent of Health left to use free cast (range 21 - 100)
			--alternate
			efgdpAltBoG = 3,			-- min BoG stack to use alt efg during DP (range 0 - 5)
			efgdpAltHealth = 95,		-- percent of Health left to use alt efg (range 21 - 100)
		
			--HA						-- applied during Holy Avenger
			efghaHP = 3,				-- min HP to use efg (range 1 - 5)
			efghaBoG = 4,				-- min BoG stack to use efg (range 0 - 5)
			efghaHealth = 75,			-- percent of Health left to use efg (range 21 - 100)
			--alternate
			efghaAltHP = 2,				-- min HP to use alternate efg (range 1 - 5)
			efghaAltBoG = 4,			-- min BoG stack to use alternate efg (range 0 - 5)
			efghaAltHealth = 95,		-- percent of Health left to use alt efg (range 21 - 100)

			--SW						-- applied during Sanctified Wrath 
			efgswHP = 3,				-- min HP to use efg (range 1 - 5)
			efgswBoG = 2,				-- min BoG stack to use efg (range 0 - 5)
			efgswHealth = 75,			-- percent of Health left to use efg (range 21 - 100)
			--alternate
			efgswAltHP = 2,				-- min HP to use alternate efg (range 1 - 5)
			efgswAltBoG = 3,			-- min BoG stack to use alternate efg (range 0 - 5)
			efgswAltHealth = 95,		-- percent of Health left to use alt efg (range 21 - 100)

			-- Word of Glory
			wogHp = 3,					-- min HP to use WoG ordinarily (range 1 - 5)
			wogBasStack = 3,			-- min BoG stack to use WoG ordinarily (range 0 - 5)
			wogPercent = 75,			-- % of Health left to use WoG ordinarily (range 21 - 100)
			--alternate					-- alternative WoG applied ordinarily
			useWoGalt = false,			-- true if player chooses the Wog alternative
			wogAltHP = 3,				-- min HP to use alternate WoG (range 1 - 5)
			wogAltBoG = 3,				-- min BoG stack to use alternate WoG (range 0 - 5)
			wogAltPct = 95,				-- % of Health left to use alt WoG (range 21 - 100)

			--4T16						-- applied while 4-piece Tier 16 set bonus is available
			wog4T16BasStack = 3,		-- min BoG stack to use WoG (range 0 - 5)
			wog4T16Percent = 75,		-- max % of Health left to use WoG (range 21 - 100)
			--alternate					-- alternative WoG 
			wog4T16AltBoG = 3,			-- min BoG stack to use alternate WoG (range 0 - 5)
			wog4T16AltPct = 95,			-- max % of Health left to use alt WoG (range 21 - 100)

			--DP
			wogdpBasStack = 3,			-- min BoG stack to use DP free cast (range 0 - 5)
			wogdpPercent = 75,			-- max % of Health left to use DP free cast (range 21 - 100)
			--alternate
			wogdpAltBoG = 3,			-- min BoG stack to alternatively use DP free cast (range 0 - 5)
			wogdpAltPct = 95,			-- max % of Health left to alt. use DP free cast (range 21 - 100)

			--HA						-- applied during Holy Avenger
			woghaHp	= 3, 				-- min HP to use WoG (range 1 - 5)
			woghaBasStack = 4,			-- min BoG stack to use WoG (range 0 - 5)
			woghaPercent = 75,			-- max % of Health left to use WoG (range 21 - 100)
			--alternate
			woghaAltHP = 3,				-- min HP to use alternate WoG (range 1 - 5)
			woghaAltBoG = 4,			-- min BoG stack to use alternate WoG (range 0 - 5)
			woghaAltPct = 95,			-- max % of Health left to use alternate WoG (range 21 - 100)

			--SW						-- applied during Sanctified Wrath
			wogswHp	= 3, 				-- min HP to use WoG (range 1 - 5)
			wogswBasStack = 2,			-- min BoG stack to use WoG (range 0 - 5)
			wogswPercent = 75,			-- max % of Health left to use WoG (range 21 - 100)
			--alternate
			wogswAltHP = 3,				-- min HP to use alternate WoG (range 1 - 5)
			wogswAltBoG = 2,			-- min BoG stack to use alternate WoG (range 0 - 5)
			wogswAltPct = 95,			-- max % of Health left to use alternate WoG (range 21 - 100)

			--Shield of the Righteous 	
			sotrHP = 5,					-- min HP to use SotR ordinarily (range 3 - 5)
			sotrBoGstk = 3,				-- min BoG stack to refresh before expiration (range 1 - 5)
			sotrBoGxp = 7,				-- refresh BoG @ __ secs. left in duration (range 3 - 12) 
			--4T16
			sotr4t16HP = 3,				-- min HP to use SotR while the 4-piece Tier 16 bonus is available (range 3 - 5)
			--DP
			sotrdpHP = 3,				-- min HP to use free cast during DP (range 0 - 5)
			sotr_dptr = 3.000,			-- secs. left for DivPurp at which proc is used unconditionally for SotR (range 3 - 6)
			--HA
			sotrhaHP = 5,				-- min HP to use SotR during HA (range 3 - 5)
			--SW
			sotrswHP = 5,				-- min HP to use SotR with SW (range 3 - 5)
				
			--other actions 
			ssRefresh = 6,				-- refresh ss at min secs. left (range 3 - 12)
			consMana = 37,				-- min percentage of mana remaining to cast Consecration

			--Optional: Timing Settings 
			-- Action Priority Times:  added to the calculated "expiration time" for action.GetCD() to return 
			-- when an action being considered for s2 is already selected for s1 
			-- minimum GCD  ( 1.0 sec. + priority time)
			  efcPrio = 0.30,
			  efgPrio = 0.25,
			  serPrio = 0.35,
			sotrxxPrio = 0.50,
			  sotrPrio = 0.55,
			  wogPrio = 0.40,
			wogxxPrio = 0.30,
			-- maximum GCD ( 1.5 sec + priority time)
			   asPrio = 0.52,
			 asgcPrio = 0.42,
 			   csPrio = 0.32,
			    jPrio = 0.37,
			 hotrPrio = 0.37,
			  howPrio = 0.57,
			   hwPrio = 0.62,
			  hwfPrio = 0.47,
			 hwswPrio = 0.27,
		},
		
		-- behavior
		updatesPerSecond = 10,
		updatesPerSecondAuras = 5,
		rangePerSkill = false,
	
		-- layout of the 2 skill buttons
		layout = 
		{
			button1 = 
			{
				size = 70,
				alpha = 1,
				x = 0,
				y = 0,
				point = "CENTER",
				pointParent = "CENTER",
			},
			button2 = 
			{
				size = 40,
				alpha = 1,
				x = 50,
				y = 0,
				point = "BOTTOMLEFT",
				pointParent = "BOTTOMRIGHT",
			},
		},
		
		-- aura buttons
		-- 4 examples, rest init to "blank" later
		auras = {},
	}
}  	--dA: end of defaults -----------------------------------------------------=


-- blank rest of the auras buttons in default options
for i = 1, MAX_AURAS do 
	defaults.profile.auras[i] = {
		enabled = false,
		data = {
			exec = "AuraButtonExecNone",
			spell = "",
			unit = "",
			byPlayer = true,
		},
		layout = {
			size = 30,
			x = 0,
			y = 0,
			alpha = 1,
			point = "BOTTOM",
			pointParent = "TOP",
		},
	}
end
-- ---------------------------------------------------------------------------------------------------------------------

-----------------------------------------------------------------------------------------------------------------------
-- talent and glyph functions 
-----------------------------------------------------------------------------------------------------------------------

function FlagTalents()

	local _, _, _, selected = GetTalentInfoByID(17583, talentGroup)		-- check for Eternal Flame
	if selected then
		if ( not s_eft ) then 											-- s_eft is initially false
			s_eft = true
			s_queue = true												-- signal GetNextAction() to call GetWorkingQueue()
		end
	elseif ( s_eft) then
		s_eft = false
		s_queue = true
	end

	local _, _, _, selected = GetTalentInfoByID(21795, talentGroup)		-- check for Sanctified Wrath
	if selected then
		if ( not s_wt ) then 											-- s_swt is initially false
			s_swt = true
			s_queue = true												-- signal GetNextAction() to call GetWorkingQueue()
		end
	elseif ( s_swt ) then 
		s_swt = false
		s_queue = true	
	end
	return 
end

function IsGlyphInSocket(glyphId)				--dA: returns true when the glyph is socketed; used in rotation.lua

	local index = 0  
	local _, enabled

	if ( glyphId ) and type(glyphId) == "number" and glyphId > 0 then
		for index = 1, NUM_GLYPH_SLOTS do
			enabled, _, _, glyphID = GetGlyphSocketInfo(index)
			if enabled then						-- enabled is nil if socket is locked (cannot be used yet)
				if glyphID == glyphId then
					return true
				end
			end
		end
		return false
	else
		print("CLCProt: clcprot IsGlyphInSocket(glyphId) received invalid glyphId: ", glyphId) 
		return false
	end
end

function CheckGlyphOfConsecration()							--dA: new function

	--set flag true/false for Glyph of Consecration and evaluate consId 
	-- consGlyphId			 	= 54928	 -- Glyph of Consecration 
	-- consIdGlyphed			= 116467 -- consecration with gylph
	-- consIdNoGlyph			= 26573  -- consecration without glyph 	

	s_goc = IsGlyphInSocket(54928)							-- global s_goc init false		
	if ( s_goc ) and consId == 26573 then 					-- global consId init without glyph
		consId = 116467					-- consecration with glyph
		print("CLCProt: Consecration is targeted (Glyph of Consecration).")
		s_queue = true										--dA: global flag signals GetNextAction() to call GetWorkingQueue()
	elseif ( not s_goc ) and consId == 116467 then
		consId = 26573					-- consecration without glyph
		print("CLCProt: Consecration is centered at the paladin (default).")
		s_queue = true										--dA: global flag signals GetNextAction() to call GetWorkingQueue()
	end
end
--[[
function CheckGlyphOfFinalWrath()							--dA: new function

	--sets flag true/false for Glyph of Final Wrath ID 54935

	s_gfw = IsGlyphInSocket(54935)							-- global s_gfw init false; returns true if socketed
	if ( s_gfw ) and ( not s_hwFinal ) then 				-- local s_hwFinal init is false
		s_hwFinal = true
		print("CLCProt: Final Wrath is enabled with Holy Wrath.")
		s_queue = true										--dA: global flag signals GetNextAction() to call GetWorkingQueue()
	elseif ( not s_gfw ) and ( s_hwFinal ) then
		s_hwFinal = false
		print("CLCProt: Glyph of Final Wrath has been removed.")
		s_queue = true										--dA: global flag signals GetNextAction() to call GetWorkingQueue()
	end
end
--]]

function CheckDefaultPriority()

	local db = clcprot.db.profile.rotation

	if db.defaultPrioAlt and ( not useAltPrio ) then
		useAltPrio = true
		print("CLCProt: Alternate priority sequence is now default: ", db.prioAlt)
	elseif not db.defaultPrioAlt and ( useAltPrio ) then 
		useAltPrio = false
		print("CLCProt: Normal priority sequence is now default: ", db.prio)
	end
end

-- ---------------------------------------------------------------------------------------------------------------------
-- MAIN UPDATE FUNCTION
-- ---------------------------------------------------------------------------------------------------------------------

local throttle = 0
local throttleAuras = 0

local function OnUpdate(self, elapsed)
	throttle = throttle + elapsed
	if throttle > clcprot.scanFrequency then
		throttle = 0
		clcprot:CheckQueue()											--dA: see clcprot:PLAYER_TALENT_UPDATE() 
		clcprot:CheckRange()
	end

	throttleAuras = throttleAuras + elapsed
	if throttleAuras > clcprot.scanFrequencyAuras then
		throttleAuras = 0
		for i = 1, numEnabledAuraButtons do
			-- TODO: check docs to see how it's done properly			--dA: nothing inspires confidence like the truth :-0
			auraIndex = enabledAuraButtons[i]
			clcprot[db.auras[auraIndex].data.exec]()
		end
	end

end
-- ---------------------------------------------------------------------------------------------------------------------


-- ---------------------------------------------------------------------------------------------------------------------
-- INIT
-- ---------------------------------------------------------------------------------------------------------------------

function clcprot:ProfileChanged(db, sourceProfile)
	-- relink 
	ReloadUI()
end

-- load if needed and show options
local function ShowOptions()
	if not clcprot.optionsLoaded then LoadAddOn("CLCProt_Options") end
	InterfaceOptionsFrame_OpenToCategory("CLCProt")
end

local function CmdLinePrio(args)
	clcprot.db.profile.rotation.prio = args
	clcprot.RR_UpdateQueue()
end

local function CmdLinePrioAlt(args)
	clcprot.db.profile.rotation.prioAlt = args
	clcprot.RR_UpdateQueue()
end

function clcprot:OnInitialize()
	-- SAVEDVARS
	self.db = LibStub("AceDB-3.0"):New("clcprotDB", defaults)				
	self.db.RegisterCallback(self, "OnProfileChanged", "ProfileChanged")
	self.db.RegisterCallback(self, "OnProfileCopied", "ProfileChanged")
	self.db.RegisterCallback(self, "OnProfileReset", "ProfileChanged")
	db = self.db.profile

	-- this would give a proper init
	self:RegisterEvent("QUEST_LOG_UPDATE")
end
function clcprot:QUEST_LOG_UPDATE()

	self:UnregisterEvent("QUEST_LOG_UPDATE")
		
	self.CheckQueue = self.DoNothing
	
	self.LBF = LibStub('LibButtonFacade', true)
	
	-- update rates
	self.scanFrequency = 1 / db.updatesPerSecond
	self.scanFrequencyAuras = 1 / db.updatesPerSecondAuras

	t_rspan = 1 / db.updatesPerSecond 						-- the amt of time between start of one rotation and start of the next

	-- blank options page for title
	local optionFrame = CreateFrame("Frame", nil, UIParent)
	optionFrame.name = "CLCProt"
	local optionFrameLoad = CreateFrame("Button", nil, optionFrame, "UIPanelButtonTemplate")
	optionFrameLoad:SetWidth(150)
	optionFrameLoad:SetHeight(22)
	optionFrameLoad:SetText("Load Options")
	optionFrameLoad:SetPoint("TOPLEFT", 20, -20)
	optionFrameLoad:SetScript("OnClick", ShowOptions)
	InterfaceOptions_AddCategory(optionFrame)
	-- chat command that points to our category
	self:RegisterChatCommand("clcprot", ShowOptions)
	self:RegisterChatCommand("clcprotlp", CmdLinePrio)
	self:RegisterChatCommand("clcprotlpalt", CmdLinePrioAlt)

	if not db.fullDisable then
		self:RegisterEvent("PLAYER_TALENT_UPDATE")
	end
	
	self:UpdateEnabledAuraButtons()

	self:RR_UpdateQueue()
	self:InitUI()
	self:UpdateAuraButtonsCooldown()
	self:PLAYER_TALENT_UPDATE()
	
	if self.LBF then
		self.LBF:RegisterSkinCallback("clcprot", self.OnSkin, self)
		self.LBF:Group("clcprot", "Skills"):Skin(unpack(db.lbf.Skills))
		self.LBF:Group("clcprot", "Auras"):Skin(unpack(db.lbf.Auras))
	end

	-- icd stuff
	self:AuraButtonUpdateICD()
	
	--[[ DEBUG
	self:InitDebugFrame()
	--]]
end

function clcprot:OnSkin(skin, glossAlpha, gloss, group, _, colors)
	local styleDB
	if group == 'Skills' then
		styleDB = db.lbf.Skills
	elseif group == 'Auras' then
		styleDB = db.lbf.Auras
	end

	if styleDB then
		styleDB[1] = skin
		styleDB[2] = glossAlpha
		styleDB[3] = gloss
		styleDB[4] = colors
	end
	
	self:UpdateAuraButtonsLayout()
	self:UpdateSkillButtonsLayout()
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- SHOW WHEN SETTINGS
-- ---------------------------------------------------------------------------------------------------------------------

-- updates the settings from db and register/unregisters the needed events
function clcprot:UpdateShowMethod()	
	-- unregister all events first
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	self:UnregisterEvent("PLAYER_REGEN_DISABLED")
	self:UnregisterEvent("PLAYER_TARGET_CHANGED")
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	self:UnregisterEvent("UNIT_FACTION")

	if db.show == "combat" then
		if addonEnabled then
			if UnitAffectingCombat("player") then
				self.frame:Show()
			else
				self.frame:Hide()
			end
		end
		self:RegisterEvent("PLAYER_REGEN_ENABLED")
		self:RegisterEvent("PLAYER_REGEN_DISABLED")
	elseif db.show == "valid" or db.show == "boss" then
		self:PLAYER_TARGET_CHANGED()
		self:RegisterEvent("PLAYER_TARGET_CHANGED")
		self:RegisterEvent("PLAYER_ENTERING_WORLD", "PLAYER_TARGET_CHANGED")
		self:RegisterEvent("UNIT_FACTION")
	else
		if addonEnabled then
			self.frame:Show()
		end
	end
end

-- out of combat
function clcprot:PLAYER_REGEN_ENABLED()						--dA: event occurs when paladin leaves combat
	if not addonEnabled then return end
	self.frame:Hide()
end
-- in combat
function clcprot:PLAYER_REGEN_DISABLED()					--dA: event occurs when paladin enters combat
	if not addonEnabled then return end
	self.frame:Show()
end
-- target change
function clcprot:PLAYER_TARGET_CHANGED()
	if not addonEnabled then return end
	
	if db.show == "boss" then
		if UnitClassification("target") ~= "worldboss" then
			self.frame:Hide()
			return
		end
	end
	
	if UnitExists("target") and UnitCanAttack("player", "target") and (not UnitIsDead("target")) then
		self.frame:Show()
	else
		self.frame:Hide()
	end
end
-- unit faction changed - test if it gets fired everytime a target switches friend -> enemy
function clcprot:UNIT_FACTION(event, unit)
	if unit == "target" then
		self:PLAYER_TARGET_CHANGED()
	end
end

-- disable/enable according to spec
function clcprot:PLAYER_TALENT_UPDATE()
	if db.fullDisable then
--		self:CLCPROTDisable()								--dA: prior source
		self:clcprotDisable()
		return
	end

	if GetSpecialization() == 2 then
		self:clcprotEnable()

		s_protSpec = true
		-- whether protection spec is paladin's primary spec (= 1) or secondary spec (= 2)
		talentGroup = GetActiveSpecGroup()

		FlagTalents()
		if s_eft then print("CLCProt: Eternal Flame is selected.")
				 else print("CLCProt: Word of Glory is available.") 
		end
		CheckGlyphOfConsecration()
--		CheckGlyphOfFinalWrath()
		CheckDefaultPriority()

		self.CheckQueue = self.CheckQueueProt				--dA: CheckQueueProt() calls clcprot.ProtRotation() 
		dq[1], dq[2] = 31935, 31935							--dA: 31935 is avenger's shield id 
		self:UpdateShowMethod()	
	else
		s_protSpec = false
		self.CheckQueue = self.DoNothing
		self:clcprotDisable()
	end
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- UPDATE FUNCTIONS
-- ---------------------------------------------------------------------------------------------------------------------
-- just show the button for positioning
function clcprot:AuraButtonExecNone(index)
	auraButtons[auraIndex]:Show()
end

-- shows a skill always with a visible cooldown when needed
function clcprot:AuraButtonExecSkillVisibleAlways()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	-- fix the texture once
	if not button.hasTexture then
		button.hasTexture = true
		button.texture:SetTexture(GetSpellTexture(data.spell))
	end
	
	button:Show()
	
	if IsUsableSpell(data.spell) then
		button.texture:SetVertexColor(1, 1, 1, 1)
	else
		button.texture:SetVertexColor(0.3, 0.3, 0.3, 1)
	end
	
	local start, duration = GetSpellCooldown(data.spell)
	if duration and duration > 0 then
		button.cooldown:SetCooldown(start, duration)
	end
end

-- shows a skill only when out of cooldown
function clcprot:AuraButtonExecSkillVisibleNoCooldown()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	-- fix the texture once
	if not button.hasTexture then
		button.hasTexture = true
		button.texture:SetTexture(GetSpellTexture(data.spell))
	end

	local start, duration = GetSpellCooldown(data.spell)
	
	if IsUsableSpell(data.spell) then
		button.texture:SetVertexColor(1, 1, 1, 1)
	else
		button.texture:SetVertexColor(0.3, 0.3, 0.3, 1)
	end
	
	if duration and duration > 1.5 then
		button:Hide()
	else
		button:Show()
	end
end

-- shows a skill only when on cooldown
function clcprot:AuraButtonExecSkillVisibleOnCooldown()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	-- fix the texture once
	if not button.hasTexture then
		button.hasTexture = true
		button.texture:SetTexture(GetSpellTexture(data.spell))
	end

	local start, duration = GetSpellCooldown(data.spell)
	
	if duration and duration > 1.5 then
		button:Show()
		button.cooldown:SetCooldown(start, duration)
	else
		button:Hide()
	end
end

-- shows an equiped usable item always with a visible cooldown when needed
function clcprot:AuraButtonExecItemVisibleAlways()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	-- hide the item if is not equiped						--dA: prior source
	--[[
	if not IsEquippedItem(data.spell) then
		button:Hide()
		return
	end
	--]]
	
	-- fix the texture once
	if not button.hasTexture then
		button.hasTexture = true
		button.texture:SetTexture(GetItemIcon(data.spell))
	end
	
	button:Show()
	
	if IsUsableItem(data.spell) then
		button.texture:SetVertexColor(1, 1, 1, 1)
	else
		button.texture:SetVertexColor(0.3, 0.3, 0.3, 1)
	end
	
	local start, duration = GetItemCooldown(data.spell)
	if duration and duration > 0 then
		button.cooldown:SetCooldown(start, duration)
	end
end

-- shows shows an equiped usable item only when out of cooldown
function clcprot:AuraButtonExecItemVisibleNoCooldown()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	-- hide the item if is not equiped	
	--[[
	if not IsEquippedItem(data.spell) then
		button:Hide()
		return
	end
	--]]
	
	-- fix the texture once
	if not button.hasTexture then
		button.hasTexture = true
		button.texture:SetTexture(GetItemIcon(data.spell))
	end

	local start, duration = GetItemCooldown(data.spell)
	
	if IsUsableItem(data.spell) then
		button.texture:SetVertexColor(1, 1, 1, 1)
	else
		button.texture:SetVertexColor(0.3, 0.3, 0.3, 1)
	end
	
	if duration and duration > 1.5 then
		button:Hide()
	else
		button:Show()
	end
end

-- displayed when a specific spell isn't active on player
function clcprot:AuraButtonExecPlayerMissingBuff()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	if not button.hasTexture then
		button.texture:SetTexture(GetSpellTexture(data.spell))
		button.hasTexture = true
	end
	
	local name, rank, icon, count, debuffType, duration, expirationTime, caster = UnitBuff("player", data.spell)
	if not name then
		button:Show()
	else
		button:Hide()
	end
end

-- experimental item with icd stuff
-- states:
--	no icd
--  buff active
--  icd
function clcprot:AuraButtonExecICDItem()
	local index = auraIndex
	local button = auraButtons[index]
	local data = icd.data[index]
	
	if not button.hasTexture then
		local _, _, tex = GetSpellInfo(data.id)
		button.texture:SetTexture(tex)
		button.hasTexture = true
	end

	local gt = GetTime()
	if (gt - data.start) > data.durationBuff then data.active = false end
	if (gt - data.start) > data.durationICD then data.enabled = false end
	
	if data.active then 
		-- always show the button when proc is active
		button:Show()
		button.cooldown:Show()
		button.cooldown:SetCooldown(data.start, data.durationBuff)
		button:SetAlpha(1)
		
	elseif data.enabled then
		-- check how to display
		if db.icd.visibility.cd == 1 then
			button:Show()
			button:SetAlpha(1)
		elseif db.icd.visibility.cd == 2 then
			button:Show()
			button:SetAlpha(0.3)
		else
			button:Hide()
			return
		end
		
		button.cooldown:Show()
		button.cooldown:SetCooldown(data.start, data.durationICD)
	else
		if db.icd.visibility.ready == 1 then
			button:Show()
			button:SetAlpha(1)
		elseif db.icd.visibility.ready == 2 then
			button:Show()
			button:SetAlpha(0.5)
		else
			button:Hide()
		end
		
		button.cooldown:Hide()
	end
end

-- checks for a buff by player (or someone) on unit
function clcprot:AuraButtonExecGenericBuff()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	if not UnitExists(data.unit) then
		button:Hide()
		return
	end
	
	local name, rank, icon, count, debuffType, duration, expirationTime, caster = UnitBuff(data.unit, data.spell)
	if name then
		if data.byPlayer and (caster ~= "player") then
			-- player required and not found
			button:Hide()
		else
			-- found the debuff
			if duration and duration > 0 then
				button.cooldown:SetCooldown(expirationTime - duration, duration)
			end
			
			-- fix texture once
			if not button.hasTexture then
				button.texture:SetTexture(icon)
				button.hasTexture = true
			end
			
			button:Show()
			
			if count > 1 then
				button.stack:SetText(count)
				button.stack:Show()
			else
				button.stack:Hide()
			end
		end
	else
		button:Hide()
	end
end

-- checks for a debuff cast by player (or someone) on unit
function clcprot:AuraButtonExecGenericDebuff()
	local index = auraIndex
	local button = auraButtons[index]
	local data = db.auras[index].data
	
	if not UnitExists(data.unit) then
		button:Hide()
		return
	end
	
	local name, rank, icon, count, debuffType, duration, expirationTime, caster = UnitDebuff(data.unit, data.spell)
	if name then
		if data.byPlayer and (caster ~= "player") then
			button:Hide()
		else
			-- found the debuff
			if duration and duration > 0 then
				button.cooldown:SetCooldown(expirationTime - duration, duration)
			end
			
			-- fix texture once
			if not button.hasTexture then
				button.texture:SetTexture(icon)
				button.hasTexture = true
			end
			
			button:Show()
			
			if count > 1 then
				button.stack:SetText(count)
				button.stack:Show()
			else
				button.stack:Hide()
			end
		end
	else
		button:Hide()
	end
end

-- resets the vertex color when grayOOM option changes
function clcprot:ResetButtonVertexColor()
	buttons[1].texture:SetVertexColor(1, 1, 1, 1)
	buttons[2].texture:SetVertexColor(1, 1, 1, 1)
end

-- updates the 2 skill buttons
function clcprot:UpdateUI()
	-- queue
	for i = 1, 2 do
		local button = buttons[i]
		local _, _, texture = GetSpellInfo(dq[i])
		button.texture:SetTexture(texture)
		
		local start, duration = GetSpellCooldown(dq[i])
		if duration and duration > 0 then
			button.cooldown:Show()
			button.cooldown:SetCooldown(start, duration)
		else
			button.cooldown:Hide()
		end
		
		if db.grayOOM then
			local _, nomana = IsUsableSpell(nq[i])
			if nomana then 
				button.texture:SetVertexColor(0.3, 0.3, 0.3, 0.3)
			else
				button.texture:SetVertexColor(1, 1, 1, 1)
			end
		end
	end
end

function clcprot:CheckRange()

	--dA: do not check range or show melee range for AoE spells targeted with the mouse 
	----: s1_twm and s2_twm are flagged true in clcprot.ProtRotation() (in rotation.lua)

	local range
	if db.rangePerSkill then
		-- each skill shows the range of the ability
		for i = 1, 2 do
			if i == 1 and ( s1_twm ) then 
				s1_twm = false				
			elseif i == 2 and ( s2_twm ) then 
				s2_twm = false		
			elseif type(nq[i]) == "string" then 
				range = IsSpellInRange(nq[i], "target")
				if range ~= nil and range == 0 then
					buttons[i].texture:SetVertexColor(0.8, 0.1, 0.1)
				else
					buttons[i].texture:SetVertexColor(1, 1, 1)
				end
			else
				local argtype = type(nq[i])
			end 
		end
	else
		-- both skills show melee range
		range = IsSpellInRange(hrname, "target")	
		if range ~= nil and range == 0 then
			for i = 1, 2 do
				if i == 1 and ( s1_twm ) then 
					s1_twm = false
				elseif i == 2 and ( s2_twm ) then 
					s2_twm = false		
				else
					buttons[i].texture:SetVertexColor(0.8, 0.1, 0.1)
				end
			end
		else
			for i = 1, 2 do
				if i == 1 and ( s1_twm ) then 
					s1_twm = false
				elseif i == 2 and ( s2_twm ) then 
					s2_twm = false		
				else
					buttons[i].texture:SetVertexColor(1, 1, 1)
				end
			end
		end
	end
end
-- ---------------------------------------------------------------------------------------------------------------------


-- ---------------------------------------------------------------------------------------------------------------------
-- QUEUE LOGIC
-- ---------------------------------------------------------------------------------------------------------------------
-- holy blank function
function clcprot:DoNothing()
	self:clcprotDisable()
end

function clcprot:CheckQueueProt()
	dq[1], dq[2] = clcprot.ProtRotation()					--dA: clcprot.ProtRotation() is at end of rotation.lua 
	nq[1] = GetSpellInfo(dq[1])
	nq[2] = GetSpellInfo(dq[2])

	self:UpdateUI()
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- ENABLE/DISABLE
-- ---------------------------------------------------------------------------------------------------------------------
function clcprot:clcprotEnable()
	if addonInit then
		addonEnabled = true
		self.frame:Show()
	end
end

function clcprot:clcprotDisable()
	if addonInit then
		addonEnabled = false
		self.frame:Hide()
	end
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- UPDATE LAYOUT
-- ---------------------------------------------------------------------------------------------------------------------

-- toggle main frame for drag
function clcprot:ToggleLock()
	if self.locked then
		self.locked = false
		self.frame:EnableMouse(true)
		self.frame.texture:Show()
	else
		self.locked = true
		self.frame:EnableMouse(false)
		self.frame.texture:Hide()
	end
end

-- center the main frame
function clcprot:CenterHorizontally()
	db.x = (UIParent:GetWidth() - clcprotFrame:GetWidth() * db.scale) / 2 / db.scale
	self:UpdateFrameSettings()
end

-- update for aura buttons 
function clcprot:UpdateSkillButtonsLayout()
	clcprotFrame:SetWidth(db.layout.button1.size + 10)
	clcprotFrame:SetHeight(db.layout.button1.size + 10)
	
	for i = 1, 2 do
		self:UpdateButtonLayout(buttons[i], db.layout["button" .. i])
	end
end

-- update aura buttons 
function clcprot:UpdateAuraButtonsLayout()
	for i = 1, MAX_AURAS do
		self:UpdateButtonLayout(auraButtons[i], db.auras[i].layout)
	end
end

-- update aura for a single button (tmp use in options)
function clcprot:UpdateAuraButtonLayout(index)
	self:UpdateButtonLayout(auraButtons[index], db.auras[index].layout)
end

-- update a given button
function clcprot:UpdateButtonLayout(button, opt)
	local scale = opt.size / button.defaultSize
	button:SetScale(scale)
	button:ClearAllPoints()
	button:SetPoint(opt.point, clcprotFrame, opt.pointParent, opt.x / scale, opt.y / scale)
	button:SetAlpha(opt.alpha)
	button.border:SetVertexColor(unpack(db.borderColor))
	button.border:SetTexture(borderType[db.borderType])
	
	button.stack:ClearAllPoints()
	button.stack:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 4, 0)
	
	if db.zoomIcons then
		button.texture:SetTexCoord(0.05, 0.95, 0.05, 0.95)
	else
		button.texture:SetTexCoord(0, 1, 0, 1)
	end
	
	if db.noBorder then
		button.border:Hide()
	else
		button.border:Show()
	end
end

-- update scale, alpha, position for main frame
function clcprot:UpdateFrameSettings()
	self.frame:SetScale(max(db.scale, 0.01))
	-- clcprot.myppbParent:SetScale(max(db.scale, 0.01) * UIParent:GetScale())	--dA: prior source commented-out
	self.frame:SetAlpha(db.alpha)
	self.frame:SetPoint("BOTTOMLEFT", db.x, db.y)
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- INIT LAYOUT
-- ---------------------------------------------------------------------------------------------------------------------

BINDING_HEADER_CLCPROT = "CLCProt"
BINDING_NAME_TOGGLEROTATION = "Toggle Rotation"

-- initialize main frame and all the buttons
function clcprot:InitUI()
	local frame = CreateFrame("Frame", "clcprotFrame", UIParent)
	frame.unit = "player"
	frame:SetFrameStrata(strataLevels[db.strata])
	frame:SetWidth(db.layout.button1.size + 10)
	frame:SetHeight(db.layout.button1.size + 10)
	frame:SetPoint("BOTTOMLEFT", db.x, db.y)
	
	frame:EnableMouse(false)
	frame:SetMovable(true)
	frame:RegisterForDrag("LeftButton")
	frame:SetScript("OnDragStart", function(self) self:StartMoving() end)
	frame:SetScript("OnDragStop", function(self)
		self:StopMovingOrSizing()
		db.x = clcprotFrame:GetLeft()
		db.y = clcprotFrame:GetBottom()
	end)
	
	local texture = frame:CreateTexture(nil, "BACKGROUND")
	texture:SetAllPoints()
	texture:SetTexture(BGTEX)
	texture:SetVertexColor(0, 0, 0, 1)
	texture:Hide()
	frame.texture = texture

	self.frame = frame
	
	-- init main skill button
	local opt
	opt = db.layout["button1"]
	buttons[1] = self:CreateButton("SB1", opt.size, opt.point, clcprotFrame, opt.pointParent, opt.x, opt.y, "Skills", true)
	buttons[1]:SetAlpha(opt.alpha)
	buttons[1]:Show()
	
	-- init secondary skill button
	opt = db.layout["button2"]
	buttons[2] = self:CreateButton("SB2", opt.size, opt.point, clcprotFrame, opt.pointParent, opt.x, opt.y, "Skills")
	buttons[2]:SetAlpha(opt.alpha)
	buttons[2]:Show()
	
	-- aura buttons
	self:InitAuraButtons()
	
	-- set scale, alpha, position
	self:UpdateFrameSettings()
	
	addonInit = true
	self:clcprotDisable()
	self.frame:SetScript("OnUpdate", OnUpdate)
end

-- initialize aura buttons
function clcprot:InitAuraButtons()
	local data, layout
	for i = 1, MAX_AURAS do
		data = db.auras[i].data
		layout = db.auras[i].layout
		auraButtons[i] = self:CreateButton("aura"..i, layout.size, layout.point, clcprotFrame, layout.pointParent, layout.x, layout.y, "Auras")
		auraButtons[i].start = 0
		auraButtons[i].duration = 0
		auraButtons[i].expirationTime = 0
		auraButtons[i].hasTexture = false
	end
end

-- create button
function clcprot:CreateButton(name, size, point, parent, pointParent, offsetx, offsety, bfGroup, isChecked)
	name = "clcprot" .. name
	local button
	if isChecked then
		button = CreateFrame("CheckButton", name , parent)
		button:SetHighlightTexture("Interface\\Buttons\\ButtonHilight-Square", "ADD")
		button:SetCheckedTexture("Interface\\Buttons\\CheckButtonHilight", "ADD")
	else
		button = CreateFrame("Button", name , parent)
	end
	button:EnableMouse(false)
	
	button:SetWidth(64)
	button:SetHeight(64)
	
	button.texture = button:CreateTexture("$parentIcon", "BACKGROUND")
	button.texture:SetAllPoints()
	button.texture:SetTexture(BGTEX)
	
	button.border = button:CreateTexture(nil, "BORDER") -- not $parentBorder so it can work when bf is enabled
	button.border:SetAllPoints()
	button.border:SetTexture(BORDERTEX)
	button.border:SetVertexColor(unpack(db.borderColor))
	button.border:SetTexture(borderType[db.borderType])
	
--	button.cooldown = CreateFrame("Cooldown", "$parentCooldown", button)	--dA: prior source (6.0.2.0.0.01)
--  dA: next line is from CLCRet *
	button.cooldown = CreateFrame("Cooldown", "$parentCooldown", button, "CooldownFrameTemplate")
	button.cooldown:SetAllPoints(button)
	
	button.stack = button:CreateFontString("$parentCount", "OVERLAY", "TextStatusBarText")
	local fontFace, _, fontFlags = button.stack:GetFont()
	button.stack:SetFont(fontFace, 30, fontFlags)
	button.stack:SetJustifyH("RIGHT")
	button.stack:ClearAllPoints()
	button.stack:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 4, 0)
	
	button.defaultSize = button:GetWidth()
	local scale = size / button.defaultSize
	button:SetScale(scale)
	button:ClearAllPoints()
	button:SetPoint(point, parent, pointParent, offsetx / scale, offsety / scale)
	
	if self.LBF then
		self.LBF:Group("clcprot", bfGroup):AddButton(button)
	end
	
	if db.zoomIcons then
		button.texture:SetTexCoord(0.05, 0.95, 0.05, 0.95)
	end
	
	if db.noBorder then
		button.border:Hide()
	end
	
	button:Hide()
	return button
end
-- ---------------------------------------------------------------------------------------------------------------------

-- ---------------------------------------------------------------------------------------------------------------------
-- FULL DISABLE
-- ToDo: Unregister/Register all events here ?
------------------------------------------------------------------------------------------------------------------------
function clcprot:FullDisableToggle()
	if db.fullDisable then
		-- enabled
		db.fullDisable = false
		
		-- register events
		self:RegisterEvent("PLAYER_TALENT_UPDATE")
		self:RegisterCLEU()
		
		-- do the normal load rutine
		self:PLAYER_TALENT_UPDATE()
	else
		-- disabled
		db.fullDisable = true
		
		-- unregister events
		self:UnregisterEvent("PLAYER_TALENT_UPDATE")
		
		self:UnregisterEvent("PLAYER_REGEN_ENABLED")
		self:UnregisterEvent("PLAYER_REGEN_DISABLED")
		self:UnregisterEvent("PLAYER_TARGET_CHANGED")
		self:UnregisterEvent("PLAYER_ENTERING_WORLD")
		self:UnregisterEvent("UNIT_FACTION")
		
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		
		-- disable
		self:clcprotDisable()
	end
end

-- ---------------------------------------------------------------------------------------------------------------------
-- HELPER FUNCTIONS
-- ---------------------------------------------------------------------------------------------------------------------	

function clcprot:ToggleRotation(flag)						-- dA: changes default action priority sequence
	if useAltPrio then
		useAltPrio = false
		prioToggled = "qn"
	else
		useAltPrio = true
		prioToggled = "qa"
	end
end	

function clcprot:Toggle_useEFGalt()
	if useEFGalt then 
		useEFGalt = false
	else
		useEFGalt = true
	end
end

function clcprot:Toggle_useWoGalt()
	if useWoGalt then 
		useWoGalt = false
	else
		useWoGalt = true
	end
end

function clcprot:AuraButtonResetTextures()	
	for i = 1, MAX_AURAS do
		auraButtons[i].hasTexture = false
	end
end

function clcprot:AuraButtonResetTexture(index)				
	auraButtons[index].hasTexture = false
end

function clcprot:AuraButtonHide(index)	
	auraButtons[index]:Hide()
end

-- reversed and edged cooldown look for buffs and debuffs
function clcprot:UpdateAuraButtonsCooldown()
	for i = 1, MAX_AURAS do
		if (db.auras[i].data.exec == "AuraButtonExecGenericBuff") or (db.auras[i].data.exec == "AuraButtonExecGenericDebuff") then
			auraButtons[i].cooldown:SetReverse(true)
		else
			auraButtons[i].cooldown:SetReverse(false)
		end
	end
end

-- update the used aura buttons to shorten the for
function clcprot:UpdateEnabledAuraButtons()
	numEnabledAuraButtons = 0
	enabledAuraButtons = {}
	for i = 1, MAX_AURAS do
		if db.auras[i].enabled then
			numEnabledAuraButtons = numEnabledAuraButtons + 1
			enabledAuraButtons[numEnabledAuraButtons] = i
		end
	end
end

local ceAuraApplied = {
	["SPELL_AURA_APPLIED"] = true,
	["SPELL_AURA_REFRESH"] = true,
	["SPELL_AURA_APPLIED_DOSE"] = true,
}

local ceAuraRemoved = {
	["SPELL_AURA_REMOVED"] = true,
	["SPELL_AURA_REMOVED_DOSE"] = true,
}

-- icd related stuff
-- helper functions

-- reports min icd for a specified aura button
function clcprot:ICDReportMinCd(args)	
	local id = tonumber(args)
	if icd.data[id] then
		print("CLCProt: ", icd.data[id].mincd)
	else
		print("CLCProt: No data found for icd.data[",id,"]")
	end
end

-- check the aura list and enables cleu if needed, also resets all data
function clcprot:AuraButtonUpdateICD()
	icd.spells = {}
	icd.data = {}
	icd.cleu = false

	for i = 1, MAX_AURAS do
		if db.auras[i].data.exec == "AuraButtonExecICDItem" and db.auras[i].data.spell ~= "" and db.auras[i].enabled then
			local id = tonumber(db.auras[i].data.spell)
			local durationICD, durationBuff = strsplit(":", db.auras[i].data.unit)
			durationICD = tonumber(durationICD) or 0
			durationBuff = tonumber(durationBuff) or 0
			
			icd.cleu = true
			icd.spells[id] = i
			icd.data[i] = { id = db.auras[i].data.spell, durationICD = durationICD, durationBuff = durationBuff, start = 0, enabled = false, active = false, last = 0, mincd = 10000 }
		end
	end

	-- register/unregister combat log proccessing
	self:RegisterCLEU()
end

function clcprot:RegisterCLEU()
	if icd.cleu then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	else
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end
end

-- cleu dispatcher wannabe
function clcprot:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, combatEvent, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, spellType, dose, ...)
--
--dA: Vengeance (SoV) is deprecated (6.0.2.0.0.001)
--
--	
	-- return if no icd
	if not icd.cleu then return end
	
	-- icd logic
	if destName == playerName and icd.spells[spellId] then
		local i = icd.spells[spellId]
		if ceAuraApplied[combatEvent] then
			icd.data[i].start = GetTime()
			icd.data[i].cd = floor(icd.data[i].start - icd.data[i].last + 0.5)
			icd.data[i].last = icd.data[i].start
			-- check if it's a smaller cd than the one used
			if icd.data[i].start > 0 and icd.data[i].cd < icd.data[i].durationICD then
				print("CLCProt NOTICE: " .. spellId .. "(" .. GetSpellInfo(spellId) .. ") activated after " .. icd.data[i].cd .. " seconds and specified ICD is " .. icd.data[i].durationICD .. " seconds.")
			end
			-- save min cd
			if icd.data[i].cd < icd.data[i].mincd then icd.data[i].mincd = icd.data[i].cd end
			icd.data[i].enabled = true
			icd.data[i].active = true
		end
	end
end

--- END OF FILE ---------------------------------------------------------------=